## intel-hdcp 20.3.0

=== CMakeLists.txt ===
# Copyright (c) 2018, Intel Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

cmake_minimum_required(VERSION 2.8.12)

include(GNUInstallDirs)

add_definitions(-DLINUX)

# Forbid in-tree building
if(${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})
    message(STATUS "Please do out-of-tree build")
    message(FATAL_ERROR "In-tree-build detected!")
endif()

# Set compile flags
set(HDCP_COMMON_COMPILE_FLAGS
    -O2
    -D_FORTIFY_SOURCE=2
    -fstack-protector-all
    -foptimize-strlen
    -fPIE
    -fPIC
    -Wall
    -Wformat
    -Wformat-security
)

set(HDCP_C_FLAGS ${HDCP_COMMON_COMPILE_FLAGS})
set(HDCP_CXX_FLAGS ${HDCP_COMMON_COMPILE_FLAGS} -std=c++11)
set(HDCP_LD_FLAGS "-z noexecstack -z relro -z now -pie") 

# Set build type
if(DEFINED CMAKE_BUILD_TYPE AND "${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
    message(STATUS "cmake build type is DEBUG")

    set(HDCP_CXX_FLAGS ${HDCP_CXX_FLAGS} -g)
    set(HDCP_C_FLAGS ${HDCP_C_FLAGS} -g)
    add_definitions(-DLOG_CONSOLE)
    add_definitions(-DHDCP_USE_VERBOSE_LOGGING)
    add_definitions(-DHDCP_USE_FUNCTION_LOGGING)
    add_definitions(-DHDCP_USE_LINK_FUNCTION_LOGGING)
endif()

if(DEFINED CMAKE_BUILD_TYPE AND "${CMAKE_BUILD_TYPE}" STREQUAL "ReleaseInternal")
    message(STATUS "cmake build type is \"${CMAKE_BUILD_TYPE}\"")

    add_definitions(-DLOG_CONSOLE)
    add_definitions(-DHDCP_USE_VERBOSE_LOGGING)
    add_definitions(-DHDCP_USE_FUNCTION_LOGGING)
endif()

if(DEFINED CMAKE_BUILD_TYPE AND "${CMAKE_BUILD_TYPE}" STREQUAL "Release")
    message(STATUS "cmake build type is \"${CMAKE_BUILD_TYPE}\"")
endif()

# Set version
set(HDCP_VERSION_MAJOR 0)
set(HDCP_VERSION_MINOR 1)
set(HDCP_VERSION_PATCH 1)
set(HDCP_VERSION
    ${HDCP_VERSION_MAJOR}.${HDCP_VERSION_MINOR}.${HDCP_VERSION_PATCH})

# Include sub project sdk daemon
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

add_subdirectory(common ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}/common)
add_subdirectory(sdk ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/sdk)
add_subdirectory(daemon ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/daemon)

configure_file(${CMAKE_SOURCE_DIR}/config/libhdcpsdk.pc.in
            ${CMAKE_BINARY_DIR}/libhdcpsdk.pc
            @ONLY)

install(PROGRAMS ${CMAKE_BINARY_DIR}/hdcpd
        DESTINATION ${CMAKE_INSTALL_FULL_BINDIR} COMPONENT cp)
install(FILES ${CMAKE_SOURCE_DIR}/sdk/hdcpapi.h
        DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR} COMPONENT cp)
install(FILES ${CMAKE_BINARY_DIR}/libhdcpsdk.so
        DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR} COMPONENT cp)
install(FILES ${CMAKE_BINARY_DIR}/libhdcpsdk.so.${HDCP_VERSION_MAJOR}
        DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR} COMPONENT cp)
install(FILES ${CMAKE_BINARY_DIR}/libhdcpsdk.so.${HDCP_VERSION}
        DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR} COMPONENT cp)
install(FILES ${CMAKE_BINARY_DIR}/libhdcpsdk.pc
        DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig COMPONENT cp)

include(${CMAKE_SOURCE_DIR}/config/systemdservice.cmake)

message(STATUS "cmake install prefix : ${CMAKE_INSTALL_PREFIX}")
message(STATUS "hdcpd install dir : ${CMAKE_INSTALL_BINDIR}")
message(STATUS "libhdcpsdk.so install dir : ${CMAKE_INSTALL_LIBDIR}")

# Set package information
set(CPACK_GENERATOR "DEB")
set(CPACK_PACKAGE_NAME "intel-uapi-hdcp")
set(CPACK_PACKAGE_VERSION ${HDCP_VERSION})
set(CPACK_PACKAGE_VENDOR "Intel")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "intel unified hdcp deb package")
SET(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA ${CMAKE_SOURCE_DIR}/config/postinst)

set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Intel")
include(CPack)

=== common/CMakeLists.txt ===
# Copyright (c) 2018, Intel Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

cmake_minimum_required(VERSION 2.8.12)

project(common CXX)

find_package(OpenSSL REQUIRED)
find_package(Threads REQUIRED)

get_filename_component(HDCP_DIR "${CMAKE_CURRENT_SOURCE_DIR}/.." REALPATH)
include_directories(${HDCP_DIR}/sdk)

add_library(${PROJECT_NAME}
    STATIC
    clientsock.cpp
    gensock.cpp
    servsock.cpp
    socketdata.cpp)

target_compile_options(${PROJECT_NAME} PRIVATE ${HDCP_CXX_FLAGS})
set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS ${HDCP_LD_FLAGS})

=== daemon/CMakeLists.txt ===
# Copyright (c) 2018, Intel Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

cmake_minimum_required(VERSION 2.8.12)

project(hdcpd CXX)

find_package(Threads REQUIRED)
find_package(OpenSSL REQUIRED)
pkg_check_modules(LIBDRM REQUIRED libdrm)

get_filename_component(HDCP_DIR "${CMAKE_CURRENT_SOURCE_DIR}/.." REALPATH)

include_directories(${OPENSSL_INCLUDE_DIRS})
include_directories(${LIBDRM_INCLUDE_DIRS})
include_directories(${HDCP_DIR}/common)
include_directories(${HDCP_DIR}/sdk)
include_directories(${HDCP_DIR}/daemon)

add_executable(${PROJECT_NAME}
    main.cpp
    daemon.cpp
    port.cpp
    srm.cpp
    portmanager.cpp
    display_window_util_wl.cpp
)

target_compile_options(${PROJECT_NAME} PRIVATE ${HDCP_CXX_FLAGS})
set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS ${HDCP_LD_FLAGS})

target_link_libraries(${PROJECT_NAME}
    ${OPENSSL_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    common
    drm
    dl
)

=== sdk/CMakeLists.txt ===
# Copyright (c) 2018, Intel Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

cmake_minimum_required(VERSION 2.8.12)

project(hdcpsdk CXX)

find_package(Threads REQUIRED)

get_filename_component(HDCP_DIR "${CMAKE_CURRENT_SOURCE_DIR}/.." REALPATH)
include_directories(${HDCP_DIR}/common)
include_directories(${HDCP_DIR}/sdk)

add_library(${PROJECT_NAME} 
    SHARED
    hdcpapi.cpp
    session.cpp
    sessionmanager.cpp)

target_compile_options(${PROJECT_NAME} PRIVATE ${HDCP_CXX_FLAGS})
set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS ${HDCP_LD_FLAGS})
set_target_properties(${PROJECT_NAME} PROPERTIES
                    VERSION ${HDCP_VERSION} SOVERSION ${HDCP_VERSION_MAJOR})

target_link_libraries(${PROJECT_NAME}
    ${CMAKE_THREAD_LIBS_INIT}
    common
    )

=== debian/changelog ===
intel-hdcp (20.3.0-1) unstable; urgency=medium

  * Initial release (Closes: #972379)

 -- Timo Aaltonen <tjaalton@debian.org>  Sat, 17 Oct 2020 13:42:44 +0300

=== debian/control ===
Source: intel-hdcp
Priority: optional
Section: misc
Maintainer: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libdrm-dev,
 libegl-dev,
 libssl-dev,
 libwayland-dev,
 pkg-config,
 systemd,
Standards-Version: 4.5.0
Homepage: https://github.com/intel/hdcp
Vcs-Browser: https://salsa.debian.org/debian/intel-hdcp
Vcs-Git: https://salsa.debian.org/debian/intel-hdcp.git
Rules-Requires-Root: no

Package: intel-hdcp
Section: misc
Architecture: linux-any
Depends: 
 ${shlibs:Depends},
 ${misc:Depends},
Description: Intel unified HDCP implementation -- userspace daemon
 The Intel(R) unified HDCP (High-bandwidth Digital Content Protection)
 is a user space implementation to prevent copying of digital audio
 & video content across digital display interfaces. It provides Linux
 user space implementation to enable the HDCP1.4 and HDCP2.2 protection
 for external digital display interfaces (HDMI/DP).
 .
 This package contains the userspace daemon.

Package: libhdcpsdk-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends:
 libhdcpsdk0 (= ${binary:Version}),
 ${misc:Depends},
Description: Intel unified HDCP implementation -- development files
 The Intel(R) unified HDCP (High-bandwidth Digital Content Protection)
 is a user space implementation to prevent copying of digital audio
 & video content across digital display interfaces. It provides Linux
 user space implementation to enable the HDCP1.4 and HDCP2.2 protection
 for external digital display interfaces (HDMI/DP).
 .
 This package contains files needed for development.

Package: libhdcpsdk0
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Intel unified HDCP implementation -- shared library
 The Intel(R) unified HDCP (High-bandwidth Digital Content Protection)
 is a user space implementation to prevent copying of digital audio
 & video content across digital display interfaces. It provides Linux
 user space implementation to enable the HDCP1.4 and HDCP2.2 protection
 for external digital display interfaces (HDMI/DP).
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --builddir build/

=== debian/watch ===
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

opts="filenamemangle=s%(?:.*?)?intel-HDCP-?(\d[\d.]*)\.tar\.gz%intel-hdcp-$1.tar.gz%" \
   https://github.com/intel/hdcp/tags \
   (?:.*?/)?intel-HDCP-?(\d[\d.]*)\.tar\.gz
